class PN532:
    def __init__(self):
        self.time = __import__('time')
        self.I2C = i2c
        self.I2C.init(freq=100000,sda=pin20,scl=pin19)
        
    def begin(self):
        self.nfc_password = [0xff, 0xff, 0xff, 0xff, 0xff, 0xff]
        cmd_write = [0x14,0x01,0x14,0x01]
        self.nfc_enable = True
        self.write_command(cmd_write, 4)
        self.time.sleep(0.01)
        if not self.read_ack(14):
            return False
        return self.receive_ACK[12] == 0x15
    
    def scan(self, text = ""):
        if not self.nfc_enable:
            return False
        if text == "":
            return self._scan()
        else:
            if self._scan():
                if len(text) != 8:
                    for i in range(8 - len(text)):
                        text = "0" + text
            if text == self.uid:
                return True
        return False
    
    def _scan(self):
        if not self.nfc_enable:
            return False
        cmdnfc_uid = [0x4A, 1, 0x00]
        self.write_command(cmdnfc_uid, 3)
        if not self.read_ack(25):
            return False
        self.nfc_uid = self.receive_ACK[19:23]
        arr = self.receive_ACK[19:23]
        uid = ""
        for i in arr:
            if i < 16:
                uid = uid + "0" + str(hex(i))[2:]
                continue
            uid += str(hex(i))[2:]
        self.uid = uid
        if self.receive_ACK[13] != 1:
            return False
        return True
    
    def read_uid(self):
        if not self.scan():
            return "no card!"
        return self.uid
            
    def read_ack(self, x, timeout= 1):
        pn532_ack = [0x00,0x00,0xFF,0x00,0xFF,0x00]
        self.time.sleep(0.03)
        value1 = self.read_to_addr(8)
        value1 = value1[1:len(value1)-1]
        self.time.sleep(0.03)
        value2 = self.read_to_addr(x - 4)
        value2 = value2[1:len(value2)-1]
        self.receive_ACK = value1 + value2
        if pn532_ack != self.receive_ACK[:6]:
            return False
        return True
        
    def write_command(self, cmd, cmd_len):
        cmd_len = cmd_len + 1
        self.time.sleep(0.002)
        checksum = 0x00 + 0x00 + 0xFF
        value = [0x00,0x00,0xFF]
        value.append(cmd_len)
        value.append(~cmd_len + 1)
        value.append(0xD4)
        checksum += 0xD4
        for i in range(cmd_len - 1):
            value.append(cmd[i])
            checksum += cmd[i]
        tmp = checksum % 256
        value.append((~tmp)&0xff)
        value.append(0x00)
        self.write_to_addr(value)
        
    def write_to_addr(self, value):
        self.I2C.write(0x24, bytearray(value))

    def read_to_addr(self, lens):
        return list(self.I2C.read(0x24, lens))
